#include "zsh.h"
#include "ctypes.h"

int CURDRV()  /**/
{
    ULONG drivenum;
    ULONG drivemap;
    DosQueryCurrentDisk( &drivenum, &drivemap );
    return drivenum-1;
}

void drivenameupper(s) /**/
char *s;
{
    int c;

    if (*(s + 1) == ':' && ((c = *s) >= 'a' && c <= 'z'))
	*s = 'A' + c - 'a';
}

char *convert_slash_to_backslash (pathname) /**/
char *pathname;
{
    int i;

    for (i = 0; i < strlen (pathname); i++) {
	if (pathname[i] == '/') pathname[i] = '\\';
    }
    return pathname;
}

char *convert_backslash_to_slash2 (p) /**/
char *p;
{
    int i;
    convert_backslash_to_slash(p);
    if (p[(i = strlen(p)) - 1] == '/' &&
	!(i == 1 || (i == 3 && p[1] == ':')))
	p[i - 1] = '\0';
    return p;
}

char *convert_backslash_to_slash (pathname) /**/
char *pathname;
{
    int i;

    for (i = 0; i < strlen (pathname); i++) {
	if (isSkanji(pathname[i])) i++;
	else if (pathname[i] == '\\') pathname[i] = '/';
    }
    return pathname;
}

char *sysroot(name) /**/
char *name;
{
    static char buf[MAXPATHLEN];
    char *p;
    buf[0] = '\0';
    if ( (p = zgetenv("SYSROOT")) ) {
	strcpy(buf, p);
	convert_backslash_to_slash(buf);
	if (buf[0] && buf[strlen(buf) - 1] == '/')
	    buf[strlen(buf) - 1] = '\0';
    }
    strcat(buf, name);
    return buf;
}

int lstat( n, s )				/**/
char* n;
struct stat* s;
{
    return stat( n, s );
}

int readlink( n, b, i )				/**/
char* n;
char* b;
int i;
{
    b[0] = 0;
    return 0;
}

int setpgrp( a, b )				/**/
int a;
int b;
{
    return 0;
}

int nice( n )					/**/
int n;
{
    return 0;
}

char* ttyname( i )				/**/
int i;
{
    return NULL;
}

void gethostname(hostnam, num) /**/
char *hostnam;
int num;
{
    char *hn;
    if ((hn = getenv("HOSTNAME"))) {
	if (strlen(hn) < num)
	    strcpy(hostnam, hn);
	else {
	    strncpy(hostnam, hn, num-1);
	    hostnam[num-1] = 0;
	}
    } else
	hostnam[0] = 0;
}

